Draft: Curva di Bézier cubica

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Draft CubicBezCurve and the translation is 97% complete.

Outdated translations are marked like this.
Other languages:
English • ‎français • ‎italiano
Arrow-left.svg Draft BezCurve.svg Curva di Bézier Pagina precedente:
Pagina successiva: Etichetta Draft Label.svg Arrow-right.svg

Draft CubicBezCurve.svg Curva di Bézier cubica

Posizione nel menu
Draft → Strumenti Bezier → Curva di Bézier cubica
Ambiente
Draft, Arch
Avvio veloce
Introdotto nella versione
-
Vedere anche
Polilinea, B-spline, Curva di Bézier


Descrizione

Lo strumento Curva di Bézier cubica crea unaCurva di Bézier di terzo grado (sono richiesti quattro punti). Questa è una delle curve di Bezier più usate nelle applicazioni di computer grafica. Questo strumento consente di creare una grande spline composta da diversi segmenti Bezier di 3° grado, in un modo simile allo strumento Bezier in Inkscape. Una curva generica di Bezier di qualsiasi grado può essere creata con lo strumento Curva di Bézier.

Gli strumenti Curva di Bézier e Curva di Bézier cubica utilizzano i punti di controllo per definire la posizione e la curvatura della spline; invece lo strumento B-spline specifica i punti esatti attraverso i quali passa la curva.

Draft CubicBezCurve example.png

Spline cubica di Bezier definita da tre segmenti. Ogni Bezier cubica è definita da quattro punti, ma quando lo strumento viene utilizzato graficamente, vengono posizionati solo tre di questi punti: 1-2-3 per il primo segmento, 3-4-5 per il secondo segmento e 5-6-7 per il terzo segmento; il quarto punto in ciascun segmento è definito implicitamente; l'ultimo punto 8 è necessario per completare l'operazione e farebbe parte di un quarto segmento di Bezier se l'operazione viene continuata.


Utilizzo

  1. Premere il pulsante Draft CubicBezCurve.svg Curva di Bézier cubica.
  2. Fare clic su un primo punto nella vista 3D e tenere premuto il pulsante del mouse (1); questo è il primo punto finale..
  3. Trascinare il puntatore su un altro punto della vista 3D e rilasciare il pulsante del mouse (2); questo è il primo punto di controllo..
  4. Spostare il puntatore su un altro punto della vista 3D, fare clic e tenere premuto il pulsante del mouse su questo punto (3); questo è il secondo punto finale.
  5. Spostare il puntatore su un altro punto della vista 3D per regolare la curvatura finale della spline, quindi rilasciare il pulsante del mouse (4)
  6. A questo punto si ha già una curva di Bezier di terzo grado. Il comando può essere completato premendo Esc o il pulsante Chiudi, oppure si può ripetere il processo facendo clic e tenendo premuto (5), trascinando e rilasciando (6) per aggiungere altri segmenti di Bezier di terzo grado.

Notare che con questo flusso di lavoro sono necessarie due sequenze di click-hold-rilascio per creare una singola curva di Bezier di terzo grado.

  • Il primo click-hold definisce il primo punto finale.
  • Il primo rilascio definisce il primo punto di controllo.
  • Il secondo click-hold definisce il secondo punto finale e la direzione generale della spline.
  • Il secondo rilascio definisce la curvatura finale della spline.
  • Il secondo punto di controllo non viene specificato esplicitamente, ma viene determinato dalla posizione del puntatore durante il secondo rilascio.

Nota per quando si creano molti segmenti di Bezier

  • Il secondo rilascio corrisponde anche al primo punto di controllo della successiva curva di Bezier.
  • Ciò significa che il secondo click-hold è anche il primo punto finale della seconda curva di Bezier.
  • Un terzo click-hold sarebbe il secondo punto finale.
  • Un terzo rilascio definirebbe la curvatura finale della seconda curva e sarebbe anche il primo punto di controllo di una terza curva.

Ciò significa che per ogni due sequenze click-hold (c-h) e rilascio (r), la seconda sequenza fa già parte di un successivo segmento di curva, come indicato nel seguente grafico:

|c-h -- r -- c-h -- r| 1
            |c-h -- r -- c-h -- r| 2
                        |c-h -- r -- c-h -- r| 3
                                    |c-h -- r -- c-h -- r| 4

Come posizionare esattamente i punti di controllo

L'operazione grafica di questo strumento consente all'utente di specificare solo il primo punto di controllo della curva quando viene disegnata. Il secondo punto di controllo può essere regolato dopo la creazione dell'oggetto: fare doppio clic sull'oggetto curva nella vista ad albero, oppure selezionarlo e premere Draft Edit.svg Modifica. Quindi trascinare il secondo punto di controllo nella posizione desiderata.

Per scegliere esattamente entrambi i punti finali e entrambi i punti di controllo, è necessario utilizzare il comando Python Draft.makeBezCurve(). Vedere la sezione Script.

Opzioni

Vedere le opzioni in Curva di Bezier.

Proprietà

Vedere le proprietà in Curva di Bezier.

Script

Vedere anche: Draft API e Nozioni di base sugli script di FreeCAD.

Per informazioni di carattere generale vedere Curva di Bézier. Una Bezier cubica viene creata passando l'opzione degree=3 a makeBezCurve().

Per ogni segmento di Bezier cubica devono essere utilizzati quattro punti, di cui i due punti intermedi sono i punti di controllo.

  • Se vengono assegnati solo 3 punti, viene creata una Bezier quadratica.
  • Se vengono assegnati solo 2 punti, viene creata una Bezier lineare, ovvero una linea retta.
  • Se vengono assegnati 5 punti, i primi 4 creano un segmento di Bezier cubico; il quarto e il quinto punto vengono utilizzati per creare una linea retta.
  • Se vengono assegnati 6 punti, i primi 4 creano un segmento cubico di Bezier; il quarto e gli altri due punti vengono utilizzati per creare un segmento quadratico di Bezier.
  • Se vengono assegnati 7 punti, i primi 4 creano un segmento cubico di Bezier; il quarto e gli altri tre sono usati per creare un secondo segmento cubico di Bezier.
  • Cioè, quando possibile, l'ultimo punto in una Bezier cubica è condiviso con i punti seguenti.

Draft CubicBezCurve API example.png

Esempi di curve di Bezier prodotte utilizzando 2, 3, 4, 5, 6, 7 e 8 punti. Le linee continue indicano segmenti cubici di Bezier; le altre linee sono quadratiche o lineari.


Esempio:

import FreeCAD as App
import Draft

p1 = App.Vector(-3500, 0, 0)
p2 = App.Vector(-3000, 2000, 0)
p3 = App.Vector(-1100, 2000, 0)
p4 = App.Vector(0, 0, 0)

p5 = App.Vector(1500, -2000, 0)
p6 = App.Vector(3000, -1500, 0)
p7 = App.Vector(5000, 0, 0)
p8 = App.Vector(6000, 1500, 0)
rot = App.Rotation()

c1 = Draft.makeCircle(100, placement=App.Placement(p1, rot), face=False)
c1.Label = "B1_E1"
c2 = Draft.makeCircle(50, placement=App.Placement(p2, rot), face=True)
c2.Label = "B1_c1"
c3 = Draft.makeCircle(50, placement=App.Placement(p3, rot), face=True)
c3.Label = "B1_c2"
c4 = Draft.makeCircle(100, placement=App.Placement(p4, rot), face=False)
c4.Label = "B1_E2"
c5 = Draft.makeCircle(50, placement=App.Placement(p5, rot), face=True)
c5.Label = "B2_c3"
c6 = Draft.makeCircle(50, placement=App.Placement(p6, rot), face=True)
c6.Label = "B2_c4"
c7 = Draft.makeCircle(100, placement=App.Placement(p7, rot), face=False)
c7.Label = "B2_E3"
c8 = Draft.makeCircle(50, placement=App.Placement(p8, rot), face=True)
c8.Label = "B3_c5"
App.ActiveDocument.recompute()

B1 = Draft.makeBezCurve([p1, p2], degree=3)
B1.Label = "B_lin"
B1.ViewObject.DrawStyle = "Dashed"

B2 = Draft.makeBezCurve([p1, p2, p3], degree=3)
B2.Label = "B_quad"
B2.ViewObject.DrawStyle = "Dotted"

B3 = Draft.makeBezCurve([p1, p2, p3, p4], degree=3)
B3.Label = "B_cub"
B3.ViewObject.LineWidth = 4

B4 = Draft.makeBezCurve([p1, p2, p3, p4, p5], degree=3)
B4.Label = "B_cub+lin"
B4.ViewObject.DrawStyle = "Dashed"

B5 = Draft.makeBezCurve([p1, p2, p3, p4, p5, p6], degree=3)
B5.Label = "B_cub+quad"
B5.ViewObject.DrawStyle = "Dotted"

B6 = Draft.makeBezCurve([p1, p2, p3, p4, p5, p6, p7], degree=3)
B6.Label = "B_cub+cub"
B6.ViewObject.LineWidth = 2

B7 = Draft.makeBezCurve([p1, p2, p3, p4, p5, p6, p7, p8], degree=3)
B7.Label = "B_cub+cub+lin"
B7.ViewObject.DrawStyle = "Dashed"
App.ActiveDocument.recompute()
Arrow-left.svg Draft BezCurve.svg Curva di Bézier Pagina precedente:
Pagina successiva: Etichetta Draft Label.svg Arrow-right.svg